# fortios_system_firmware_upgrade – Perform firmware upgrade on FortiGate or FortiOS (FOS) device

New in version 2.9.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- This module is able to perform firmware upgrade on FortiGate or FortiOS (FOS) device by specifying firmware upgrade source, filename and whether format boot partition before upgrade. Examples include all parameters and values need to be adjusted to datasources before usage. Tested with FOS v6.0.2

## Requirements

The below requirements are needed on the host that executes this module.

- fortiosapi>=0.9.8

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
host string |  | FortiOS or FortiGate IP address.

https
boolean

Choices:
- no
- yes ←

Indicates if the requests towards FortiGate must use HTTPS protocol.

password string | Default: "" | FortiOS or FortiGate password.

ssl_verify
boolean

Choices:
- no
- yes ←

Ensures FortiGate certificate must be verified by a proper CA.

system_firmware dictionary / required | Default: null | Possible parameters to go in the body for the request. Specify firmware upgrade source, filename and whether format boot partition before upgrade
| file_content string |  | Provided when uploading a file: base64 encoded file data. Must not contain whitespace or other invalid base64 characters. Must be included in HTTP body.
| filename string / required |  | Name and path of the local firmware file.

format_partition
boolean

Choices:
- no
- yes

Set to true to format boot partition before upgrade.

source
string / required

Choices:
- upload
- usb
- fortiguard

Firmware file data source [upload|usb|fortiguard].

username string |  | FortiOS or FortiGate username.
vdom string | Default: "root" | Virtual domain, among those defined previously. A vdom is a virtual instance of the FortiGate that can be configured and used as a different unit.

## Notes

Note

- Requires fortiosapi library developed by Fortinet
- Run as a local_action in your playbook

## Examples

    - hosts: localhost
      vars:
       host: "192.168.122.40"
       username: "admin"
       password: ""
       vdom: "root"
       ssl_verify: "False"
      tasks:
      - name: Perform firmware upgrade with local firmware file.
        fortios_system_firmware:
          host:  "{{ host }}"
          username: "{{ username }}"
          password: "{{ password }}"
          vdom:  "{{ vdom }}"
          ssl_verify: "False"
          system_firmware:
            file_content: "<your_own_value>"
            filename: "<your_own_value>"
            format_partition: "<your_own_value>"
            source: "upload"
        register: fortios_system_firmware_upgrade_result

      - debug:
          var:
            # please check the following status to confirm
            fortios_system_firmware_upgrade_result.meta.results.status

      - name: Perform firmware upgrade with firmware file on USB.
        fortios_system_firmware_upgrade:
          host:  "{{ host }}"
          username: "{{ username }}"
          password: "{{ password }}"
          vdom:  "{{ vdom }}"
          ssl_verify: "False"
          system_firmware:
            filename: "<your_own_value>"
            format_partition: "<your_own_value>"
            source: "usb"
        register: fortios_system_firmware_upgrade_result

      - debug:
          var:
            # please check the following status to confirm
            fortios_system_firmware_upgrade_result.meta.results.status

      - name: Perform firmware upgrade from FortiGuard.
        fortios_system_firmware_upgrade:
          host:  "{{ host }}"
          username: "{{ username }}"
          password: "{{ password }}"
          vdom:  "{{ vdom }}"
          ssl_verify: "False"
          system_firmware:
            filename: "<your_own_value>"
            format_partition: "<your_own_value>"
            source: "fortiguard"
        register: fortios_system_firmware_upgrade_result

      - debug:
          var:
            # please check the following status to confirm
            fortios_system_firmware_upgrade_result.meta.results.status

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
build string | always | Build number of the fortigate image Sample: 1547
http_method string | always | Last method used to provision the content into FortiGate Sample: POST
name string | always | Name of the table used to fulfill the request Sample: firmware
path string | always | Path of the table used to fulfill the request Sample: system
revision string | always | Internal revision number Sample: 17.0.2.10658
serial string | always | Serial number of the unit Sample: FGVMEVYYQT3AB5352
status string | always | Indication of the operation's result Sample: success
vdom string | always | Virtual domain used Sample: root
version string | always | Version of the FortiGate Sample: v5.6.3

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Don Yao (@fortinetps)
- Miguel Angel Munoz (@mamunozgonzalez)
- Nicolas Thomas (@thomnico)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.